unit M33Main;

interface

{ predem se omlouvam za svoje obcasne dvojjazycne nazvy procedur(napr. LoadSlova) }

{ jak bude fungovat opravovani:
  protoze nevim, jak nastavit pozici kurzoru v MEMU a vubec jak ho domutit
  nejak rozumne delat to, co ja chci, funguji opravy takto:

  pri nalezeni chyby se cast textu okolo ni zobrazi v mensim MEMU vlevo.

  Pak jsou tri moznosti: 1. opravit to v tom MEMU (vcetne okolniho textu)
                         2. napsat dolu do comboboxu jen jiny tvar toho slova(opravi se jen ono)
                         3. vybrat si v comboboxu jednu z nabizenych moznosti (asi to nestihnu)

  Pokud opravite nejake slovo nebo celou cast textu, pozice opravy se nastavi na zacatek teto casti,
  aby se pro jistotu projela znova. Pokud to uz chcete nechat, kliknete na "bez opravy" 
}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  M33Class, M33Thread, StdCtrls, ExtCtrls;

const
  SlovnikFile   = 'dict.txt';

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    StavLabel: TLabel;
    InputEdit: TEdit;
    Label2: TLabel;
    InButt: TButton;
    OutButt: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Button1: TButton;
    Bevel1: TBevel;
    Button2: TButton;
    Label3: TLabel;
    PozLabel: TLabel;
    ZacButt: TButton;
    Memo: TMemo;
    ErMemo: TMemo;
    Label4: TLabel;
    ErLabel: TLabel;
    Label5: TLabel;
    OpravaBox: TComboBox;
    RepBut1: TButton;
    RepBut2: TButton;
    StaleBox: TCheckBox;
    BezButt: TButton;
    Label6: TLabel;
    Label7: TLabel;
    SlovButt: TButton;
    PodobBox: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure InButtClick(Sender: TObject);
    procedure OutButtClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ZacButtClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RepBut1Click(Sender: TObject);
    procedure RepBut2Click(Sender: TObject);
    procedure BezButtClick(Sender: TObject);
    procedure SlovButtClick(Sender: TObject);
  private
    { Private declarations }
    foprava         : boolean; { probiha oprava? }
    procedure Term(Sender: TObject); { kdyz dojede thread }
    procedure SetOprava(value : boolean);
  public
    { Public declarations }
    Sl                   : tslovnik;
    First,ComLine        : Boolean;  { FIRST: jestli se uz vyvolalo OnActivate }
                                     { CONLINE: pracuju z prik. radky? }
    Thread               : TSlovnikThread;

    oprpoz               : tpozice; { pozice slova na opravu }
    oprslovo             : string; { slovo do opravy }
    change               : boolean; { zmenil se text? }

    property oprava : boolean read foprava write setoprava;
    
    procedure MojeZprava; { kdyz thread neco najde, zavola mi }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.SetOprava(value : boolean);
begin

  foprava := value;
  opravabox.enabled := value;
  RepBut1.enabled := value;
  RepBut2.enabled := value;
  BezButt.enabled := value;
  SlovButt.enabled := value;
  ZacButt.enabled := not value;

end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
{}
  Repaint;
  
  if first then exit;
  first := true;  { tohle pujde jen jednou }


    { tyhle veci by se normalne mely delat spis na OnCreate, ale
      takhle bude videt okno. Serazeni slovniku trva docela dlouho,
      nebylo by nic videt }
  oprava := false;
  stavlabel.caption := 'Natm slovnk';
  stavlabel.Repaint;

  sl := tslovnik.create; { zalozim si slovnik }
  sl.NactiSlova(SlovnikFile);

  ComLine := paramcount<>0; { jedu z prik. radky }
  if (ComLine) and ((paramcount<>2) or (not FileExists(paramstr(1)))) then
   begin
    ShowMessage('patn zadn na pkazov dce');
    ComLine := False;
   end;

  thread := tslovnikthread.Create(sl,nil,comline);
  with thread do
   begin
    onterminate := term;
    freeonterminate := true;
   end;
   { thread si zalozim v kazdem pripade, otazka je, co bude delat }
  if ComLine then
   begin
    stavlabel.caption := 'Zpracovvm automaticky';
    with thread do
     begin
      FileIn := paramstr(1);
      FileOut := paramstr(2);
      Auto := true;
      Resume; { a jedeme }
     end;
   end else
    begin
     stavlabel.caption := 'Nic';
     thread.Auto := false;
    end;

end;

procedure TMainForm.Term(Sender: TObject);
begin
  if not ComLine then exit;
  close;
  thread := nil;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{}
  if assigned(thread) then
   begin
    if thread.Suspended then thread.resume;
    thread.terminate; { pokud bezi, tak ho zavru }
   end;
end;

procedure TMainForm.InButtClick(Sender: TObject);
begin
  if opendialog.Execute then inputedit.text := opendialog.filename;
end;

procedure TMainForm.OutButtClick(Sender: TObject);
begin
  if savedialog.Execute then
   begin
    sl.Inp.savetofile(savedialog.filename);
    change := false;
   end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
{}
  if change then if messagebox(handle,'Text nebyl uloen. Chcete pesto nahrt jin ?','Varovn',4) <> MRYES then exit;

  oprava := false;
  change := false;
  if not fileexists(inputedit.text) then
   begin
    showmessage('Nejde to nast');
    exit;
   end;
  sl.NactiVstup(inputedit.text);
  memo.lines.assign(sl.inp);

end;

procedure TMainForm.ZacButtClick(Sender: TObject);
begin
  sl.Zacatek;
  pozlabel.caption := '0:1';
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
{}
  oprava := false;
  stavlabel.caption := 'Kontroluji';
  while thread.suspended do thread.Resume;
end;

procedure TMainForm.MojeZprava;
var
  n   : integer;  { cykly }

begin

  if sl.Konec then begin stavlabel.caption := 'Nic - konec souboru'; exit; end;
  stavlabel.caption := 'Chyba';
  erlabel.caption :=  sl.aktslov;
  oprava := true;
  oprpoz := sl.SlovPoz;
  oprslovo := sl.aktslov;

  ermemo.clear;
  for n := sl.SlovPoz.radka-1 to sl.SlovPoz.radka+1 do if (n>=0) and (n<sl.inp.count) then
   ermemo.lines.add(sl.inp.strings[n]);
  opravabox.text := sl.aktslov;

  if podobbox.checked then
   begin
    opravabox.Items.assign(thread.podobna);
    opravabox.ItemIndex := 0; { najdu podobna slova }
   end; 

end;

procedure TMainForm.RepBut1Click(Sender: TObject);
var
  n,m,y   : integer; { cykly, pozice }

begin
{}
  oprava := false;
  erlabel.caption := '!Opraveno!';

  y := oprpoz.radka-1;
  if y < 0 then y := 0;
  for n := oprpoz.radka+1 downto oprpoz.radka-1 do if (n>=0) and (n<sl.inp.count) then
   sl.inp.delete(n);

  for n := ermemo.lines.count-1 downto 0 do sl.inp.Insert(y,ermemo.lines.strings[n]);
  memo.lines.assign(sl.inp);
   { tohle nahore smaze z hlavniho seznamu ty tri radky a nahradi je
     radkami z opravy ( nemusi byt tri, muzete tam napsat cokoli !! ) }

  sl.setpozice(y,1); { pozice pred ten text }

  if stalebox.Checked then button2click(self);
  change := true;

end;

procedure TMainForm.RepBut2Click(Sender: TObject);
begin
{}
  erlabel.caption := '!Opraveno!';
  oprava := false;
  sl.Inp.strings[oprpoz.radka] := copy(sl.inp.strings[oprpoz.radka],1,oprpoz.index-1)+
   opravabox.text+copy(sl.inp.strings[oprpoz.radka],oprpoz.index+length(oprslovo),9999);
  memo.lines.assign(sl.inp);
  
  sl.setpozice(oprpoz.radka,oprpoz.index);

  if stalebox.Checked then button2click(self);
  change := true;

end;

procedure TMainForm.BezButtClick(Sender: TObject);
begin
{}
  erlabel.caption := 'dn';
  oprava := false;
  if stalebox.Checked then button2click(self);
  
end;

procedure TMainForm.SlovButtClick(Sender: TObject);
begin
{}
  oprava := false;
  sl.Slova.add(oprslovo);

end;

end.
